﻿/*  代码由框架生成,任何更改都可能导致被代码生成器覆盖，可自行修改。
* Ghre_Exam.cs
*
*功 能： N / A
* 类 名： Ghre_Exam
*
* Ver    变更日期 负责人  变更内容
* ───────────────────────────────────
*V0.01  2024/5/28 18:09:05  SimonHsiao   初版
*
* Copyright(c) 2024 Tiobon Corporation. All Rights Reserved.
*┌──────────────────────────────────┐
*│　此技术信息为本公司机密信息，未经本公司书面同意禁止向第三方披露．　│
*│　作者：SimonHsiao                                                  │
*└──────────────────────────────────┘
*/ 
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace Tiobon.Core.Model.Models
{

    /// <summary>
    /// 考试 (Dto.Base)
    /// </summary>
    public class Ghre_ExamBase
    {

        /// <summary>
        /// 关联类型
        /// </summary>
        [Display(Name = "LinkType"), Description("关联类型"), MaxLength(32, ErrorMessage = "关联类型 不能超过 32 个字符")]
        public string LinkType { get; set; }

        /// <summary>
        /// 课程场景ID
        /// </summary>
        public long? CourseSceneId { get; set; }

        /// <summary>
        /// 课程ID
        /// </summary>
        public long? CourseId { get; set; }

        /// <summary>
        /// 试卷ID
        /// </summary>
        public long? ExamPaperId { get; set; }

        /// <summary>
        /// 封面图片URL
        /// </summary>
        [Display(Name = "CoverUrl"), Description("封面图片URL"), MaxLength(256, ErrorMessage = "封面图片URL 不能超过 256 个字符")]
        public string CoverUrl { get; set; }

        /// <summary>
        /// 考试编号
        /// </summary>
        [Display(Name = "ExamNo"), Description("考试编号"), MaxLength(32, ErrorMessage = "考试编号 不能超过 32 个字符")]
        public string ExamNo { get; set; }

        /// <summary>
        /// 考试名称
        /// </summary>
        [Display(Name = "ExamName"), Description("考试名称"), MaxLength(32, ErrorMessage = "考试名称 不能超过 32 个字符")]
        public string ExamName { get; set; }

        /// <summary>
        /// 日期类型
        /// </summary>
        [Display(Name = "DateType"), Description("日期类型"), MaxLength(32, ErrorMessage = "日期类型 不能超过 32 个字符")]
        public string DateType { get; set; }

        /// <summary>
        /// 开始时间
        /// </summary>
        public DateTime? BeginTime { get; set; }

        /// <summary>
        /// 结束时间
        /// </summary>
        public DateTime? EndTime { get; set; }

        /// <summary>
        /// 学完多久
        /// </summary>
        public int? AfterHowLong { get; set; }

        /// <summary>
        /// 考试形式
        /// </summary>
        [Display(Name = "ExamMode"), Description("考试形式"), MaxLength(32, ErrorMessage = "考试形式 不能超过 32 个字符")]
        public string ExamMode { get; set; }

        /// <summary>
        /// 是否关联开班
        /// </summary>
        public bool? IsLinkOpenClass { get; set; }

        /// <summary>
        /// 开班ID
        /// </summary>
        public long? OpenClassId { get; set; }

        /// <summary>
        /// 状态
        /// </summary>
        [Display(Name = "Status"), Description("状态"), MaxLength(32, ErrorMessage = "状态 不能超过 32 个字符")]
        public string Status { get; set; }

        /// <summary>
        /// 线下考试地点
        /// </summary>
        [Display(Name = "ExamPlace"), Description("线下考试地点"), MaxLength(64, ErrorMessage = "线下考试地点 不能超过 64 个字符")]
        public string ExamPlace { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [Display(Name = "RemarkSz"), Description("备注"), MaxLength(2000, ErrorMessage = "备注 不能超过 2000 个字符")]
        public string RemarkSz { get; set; }

        /// <summary>
        /// 默认标志
        /// </summary>
        public int? IsDefault { get; set; }

        /// <summary>
        /// 预留字段1
        /// </summary>
        [Display(Name = "Reverse1"), Description("预留字段1"), MaxLength(1000, ErrorMessage = "预留字段1 不能超过 1000 个字符")]
        public string Reverse1 { get; set; }

        /// <summary>
        /// 预留字段2
        /// </summary>
        [Display(Name = "Reverse2"), Description("预留字段2"), MaxLength(1000, ErrorMessage = "预留字段2 不能超过 1000 个字符")]
        public string Reverse2 { get; set; }

        /// <summary>
        /// 预留字段3
        /// </summary>
        [Display(Name = "Reverse3"), Description("预留字段3"), MaxLength(1000, ErrorMessage = "预留字段3 不能超过 1000 个字符")]
        public string Reverse3 { get; set; }

        /// <summary>
        /// 预留字段4
        /// </summary>
        [Display(Name = "Reverse4"), Description("预留字段4"), MaxLength(1000, ErrorMessage = "预留字段4 不能超过 1000 个字符")]
        public string Reverse4 { get; set; }

        /// <summary>
        /// 预留字段5
        /// </summary>
        [Display(Name = "Reverse5"), Description("预留字段5"), MaxLength(1000, ErrorMessage = "预留字段5 不能超过 1000 个字符")]
        public string Reverse5 { get; set; }

        /// <summary>
        /// 预留字段6
        /// </summary>
        [Display(Name = "Reverse6"), Description("预留字段6"), MaxLength(1000, ErrorMessage = "预留字段6 不能超过 1000 个字符")]
        public string Reverse6 { get; set; }

        /// <summary>
        /// 预留字段7
        /// </summary>
        [Display(Name = "Reverse7"), Description("预留字段7"), MaxLength(1000, ErrorMessage = "预留字段7 不能超过 1000 个字符")]
        public string Reverse7 { get; set; }

        /// <summary>
        /// 预留字段8
        /// </summary>
        [Display(Name = "Reverse8"), Description("预留字段8"), MaxLength(1000, ErrorMessage = "预留字段8 不能超过 1000 个字符")]
        public string Reverse8 { get; set; }

        /// <summary>
        /// 预留字段9
        /// </summary>
        [Display(Name = "Reverse9"), Description("预留字段9"), MaxLength(1000, ErrorMessage = "预留字段9 不能超过 1000 个字符")]
        public string Reverse9 { get; set; }

        /// <summary>
        /// 预留字段10
        /// </summary>
        [Display(Name = "Reverse10"), Description("预留字段10"), MaxLength(1000, ErrorMessage = "预留字段10 不能超过 1000 个字符")]
        public string Reverse10 { get; set; }

        /// <summary>
        /// 预留字段11
        /// </summary>
        public int? ReverseI1 { get; set; }

        /// <summary>
        /// 预留字段12
        /// </summary>
        public int? ReverseI2 { get; set; }
    }
}
