﻿/*  代码由框架生成,任何更改都可能导致被代码生成器覆盖，可自行修改。
* Ghre_StudyRecord.cs
*
*功 能： N / A
* 类 名： Ghre_StudyRecord
*
* Ver    变更日期 负责人  变更内容
* ───────────────────────────────────
*V0.01  2024/7/30 14:26:02  SimonHsiao   初版
*
* Copyright(c) 2024 Tiobon Corporation. All Rights Reserved.
*┌──────────────────────────────────┐
*│　此技术信息为本公司机密信息，未经本公司书面同意禁止向第三方披露．　│
*│　作者：SimonHsiao                                                  │
*└──────────────────────────────────┘
*/ 
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace Tiobon.Core.Model.Models
{

    /// <summary>
    /// 培训记录 (Dto.Base)
    /// </summary>
    public class Ghre_StudyRecordBase
    {

        /// <summary>
        /// 员工ID
        /// </summary>
        public int? StaffId { get; set; }

        /// <summary>
        /// 考试ID
        /// </summary>
        public long? ExamId { get; set; }

        /// <summary>
        /// 课程快照ID
        /// </summary>
        public long? CourseSnapId { get; set; }

        /// <summary>
        /// 课程ID
        /// </summary>
        public long? CourseId { get; set; }

        /// <summary>
        /// 课程场景ID
        /// </summary>
        public long? CourseSceneId { get; set; }


        /// <summary>
        /// 必选修规则ID
        /// </summary>
        public long? StudyRuleId { get; set; }

        /// <summary>
        /// 加入时间
        /// </summary>
        public DateTime? JoinTime { get; set; }

        /// <summary>
        /// 课程结束时间
        /// </summary>
        public DateTime? CourseBeginTime { get; set; }

        /// <summary>
        /// 课程结束时间
        /// </summary>
        public DateTime? CourseEndTime { get; set; }

        /// <summary>
        /// 开始时间
        /// </summary>
        public DateTime? BeginTime { get; set; }

        /// <summary>
        /// 结束时间
        /// </summary>
        public DateTime? EndTime { get; set; }

        /// <summary>
        /// 学习进度
        /// </summary>
        public int? StudyProgress { get; set; }

        /// <summary>
        /// 课程类型
        /// </summary>
        [Display(Name = "CourseType"), Description("课程类型"), MaxLength(32, ErrorMessage = "课程类型 不能超过 32 个字符")]
        public string CourseType { get; set; }

        /// <summary>
        /// 课程状态
        /// </summary>
        [Display(Name = "CourseStatus"), Description("课程状态"), MaxLength(32, ErrorMessage = "课程状态 不能超过 32 个字符")]
        public string CourseStatus { get; set; }

        /// <summary>
        /// 学习状态
        /// </summary>
        [Display(Name = "StudyStatus"), Description("学习状态"), MaxLength(32, ErrorMessage = "学习状态 不能超过 32 个字符")]
        public string StudyStatus { get; set; }

        /// <summary>
        /// 年度
        /// </summary>
        [Display(Name = "Year"), Description("年度"), MaxLength(32, ErrorMessage = "年度 不能超过 32 个字符")]
        public string Year { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [Display(Name = "RemarkSz"), Description("备注"), MaxLength(2000, ErrorMessage = "备注 不能超过 2000 个字符")]
        public string RemarkSz { get; set; }

        /// <summary>
        /// 默认标志
        /// </summary>
        public int? IsDefault { get; set; }

        /// <summary>
        /// 预留字段1
        /// </summary>
        [Display(Name = "Reverse1"), Description("预留字段1"), MaxLength(1000, ErrorMessage = "预留字段1 不能超过 1000 个字符")]
        public string Reverse1 { get; set; }

        /// <summary>
        /// 预留字段2
        /// </summary>
        [Display(Name = "Reverse2"), Description("预留字段2"), MaxLength(1000, ErrorMessage = "预留字段2 不能超过 1000 个字符")]
        public string Reverse2 { get; set; }

        /// <summary>
        /// 预留字段3
        /// </summary>
        [Display(Name = "Reverse3"), Description("预留字段3"), MaxLength(1000, ErrorMessage = "预留字段3 不能超过 1000 个字符")]
        public string Reverse3 { get; set; }

        /// <summary>
        /// 预留字段4
        /// </summary>
        [Display(Name = "Reverse4"), Description("预留字段4"), MaxLength(1000, ErrorMessage = "预留字段4 不能超过 1000 个字符")]
        public string Reverse4 { get; set; }

        /// <summary>
        /// 预留字段5
        /// </summary>
        [Display(Name = "Reverse5"), Description("预留字段5"), MaxLength(1000, ErrorMessage = "预留字段5 不能超过 1000 个字符")]
        public string Reverse5 { get; set; }

        /// <summary>
        /// 预留字段6
        /// </summary>
        [Display(Name = "Reverse6"), Description("预留字段6"), MaxLength(1000, ErrorMessage = "预留字段6 不能超过 1000 个字符")]
        public string Reverse6 { get; set; }

        /// <summary>
        /// 预留字段7
        /// </summary>
        [Display(Name = "Reverse7"), Description("预留字段7"), MaxLength(1000, ErrorMessage = "预留字段7 不能超过 1000 个字符")]
        public string Reverse7 { get; set; }

        /// <summary>
        /// 预留字段8
        /// </summary>
        [Display(Name = "Reverse8"), Description("预留字段8"), MaxLength(1000, ErrorMessage = "预留字段8 不能超过 1000 个字符")]
        public string Reverse8 { get; set; }

        /// <summary>
        /// 预留字段9
        /// </summary>
        [Display(Name = "Reverse9"), Description("预留字段9"), MaxLength(1000, ErrorMessage = "预留字段9 不能超过 1000 个字符")]
        public string Reverse9 { get; set; }

        /// <summary>
        /// 预留字段10
        /// </summary>
        [Display(Name = "Reverse10"), Description("预留字段10"), MaxLength(1000, ErrorMessage = "预留字段10 不能超过 1000 个字符")]
        public string Reverse10 { get; set; }

        /// <summary>
        /// 预留字段11
        /// </summary>
        public int? ReverseI1 { get; set; }

        /// <summary>
        /// 预留字段12
        /// </summary>
        public int? ReverseI2 { get; set; }
    }
}
