﻿/*  代码由框架生成,任何更改都可能导致被代码生成器覆盖，可自行修改。
* Ghre_Teacher.cs
*
*功 能： N / A
* 类 名： Ghre_Teacher
*
* Ver    变更日期 负责人  变更内容
* ───────────────────────────────────
*V0.01  2024/6/27 14:05:58  SimonHsiao   初版
*
* Copyright(c) 2024 Tiobon Corporation. All Rights Reserved.
*┌──────────────────────────────────┐
*│　此技术信息为本公司机密信息，未经本公司书面同意禁止向第三方披露．　│
*│　作者：SimonHsiao                                                  │
*└──────────────────────────────────┘
*/ 
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Tiobon.Core.Model.Models
{

    /// <summary>
    /// Ghre_Teacher (Dto.Base)
    /// </summary>
    public class Ghre_TeacherBase
    {

        /// <summary>
        /// 机构Id
        /// </summary>
        public long? SchoolId { get; set; }

        /// <summary>
        /// 部门ID
        /// </summary>
        public int? DeptID { get; set; }

        /// <summary>
        /// 员工ID
        /// </summary>
        public int? StaffId { get; set; }

        /// <summary>
        /// 讲师分类
        /// </summary>
        [Display(Name = "TeacherType"), Description("讲师分类"), MaxLength(32, ErrorMessage = "讲师分类 不能超过 32 个字符")]
        public string TeacherType { get; set; }

        /// <summary>
        /// 机构编号
        /// </summary>
        [Display(Name = "TeacherNo"), Description("机构编号"), MaxLength(32, ErrorMessage = "机构编号 不能超过 32 个字符")]
        public string TeacherNo { get; set; }

        /// <summary>
        /// 机构名称
        /// </summary>
        [Display(Name = "TeacherName"), Description("机构名称"), MaxLength(32, ErrorMessage = "机构名称 不能超过 32 个字符")]
        public string TeacherName { get; set; }

        /// <summary>
        /// 员工照片
        /// </summary>
        [Display(Name = "PhotoUrl"), Description("员工照片"), MaxLength(256, ErrorMessage = "员工照片 不能超过 256 个字符")]
        public string PhotoUrl { get; set; }

        /// <summary>
        /// 性别
        /// </summary>
        [Display(Name = "Gender"), Description("性别"), MaxLength(32, ErrorMessage = "性别 不能超过 32 个字符")]
        public string Gender { get; set; }

        /// <summary>
        /// 邮箱
        /// </summary>
        [Display(Name = "Email"), Description("邮箱"), MaxLength(64, ErrorMessage = "邮箱 不能超过 64 个字符")]
        public string Email { get; set; }

        /// <summary>
        /// 手机号码
        /// </summary>
        [Display(Name = "Mobile"), Description("手机号码"), MaxLength(32, ErrorMessage = "手机号码 不能超过 32 个字符")]
        public string Mobile { get; set; }

        /// <summary>
        /// 讲师等级
        /// </summary>
        [Display(Name = "TeacherLevel"), Description("讲师等级"), MaxLength(32, ErrorMessage = "讲师等级 不能超过 32 个字符")]
        public string TeacherLevel { get; set; }

        /// <summary>
        /// 课时费
        /// </summary>
        [Display(Name = "Price"), Description("课时费"), Column(TypeName = "decimal(20,2)")]
        public decimal? Price { get; set; }

        /// <summary>
        /// 擅长领域
        /// </summary>
        [Display(Name = "SkillPoints"), Description("擅长领域"), MaxLength(256, ErrorMessage = "擅长领域 不能超过 256 个字符")]
        public string SkillPoints { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [Display(Name = "RemarkSz"), Description("备注"), MaxLength(2000, ErrorMessage = "备注 不能超过 2000 个字符")]
        public string RemarkSz { get; set; }

        /// <summary>
        /// 默认标志
        /// </summary>
        public int? IsDefault { get; set; }

        /// <summary>
        /// 预留字段1
        /// </summary>
        [Display(Name = "Reverse1"), Description("预留字段1"), MaxLength(1000, ErrorMessage = "预留字段1 不能超过 1000 个字符")]
        public string Reverse1 { get; set; }

        /// <summary>
        /// 预留字段2
        /// </summary>
        [Display(Name = "Reverse2"), Description("预留字段2"), MaxLength(1000, ErrorMessage = "预留字段2 不能超过 1000 个字符")]
        public string Reverse2 { get; set; }

        /// <summary>
        /// 预留字段3
        /// </summary>
        [Display(Name = "Reverse3"), Description("预留字段3"), MaxLength(1000, ErrorMessage = "预留字段3 不能超过 1000 个字符")]
        public string Reverse3 { get; set; }

        /// <summary>
        /// 预留字段4
        /// </summary>
        [Display(Name = "Reverse4"), Description("预留字段4"), MaxLength(1000, ErrorMessage = "预留字段4 不能超过 1000 个字符")]
        public string Reverse4 { get; set; }

        /// <summary>
        /// 预留字段5
        /// </summary>
        [Display(Name = "Reverse5"), Description("预留字段5"), MaxLength(1000, ErrorMessage = "预留字段5 不能超过 1000 个字符")]
        public string Reverse5 { get; set; }

        /// <summary>
        /// 预留字段6
        /// </summary>
        [Display(Name = "Reverse6"), Description("预留字段6"), MaxLength(1000, ErrorMessage = "预留字段6 不能超过 1000 个字符")]
        public string Reverse6 { get; set; }

        /// <summary>
        /// 预留字段7
        /// </summary>
        [Display(Name = "Reverse7"), Description("预留字段7"), MaxLength(1000, ErrorMessage = "预留字段7 不能超过 1000 个字符")]
        public string Reverse7 { get; set; }

        /// <summary>
        /// 预留字段8
        /// </summary>
        [Display(Name = "Reverse8"), Description("预留字段8"), MaxLength(1000, ErrorMessage = "预留字段8 不能超过 1000 个字符")]
        public string Reverse8 { get; set; }

        /// <summary>
        /// 预留字段9
        /// </summary>
        [Display(Name = "Reverse9"), Description("预留字段9"), MaxLength(1000, ErrorMessage = "预留字段9 不能超过 1000 个字符")]
        public string Reverse9 { get; set; }

        /// <summary>
        /// 预留字段10
        /// </summary>
        [Display(Name = "Reverse10"), Description("预留字段10"), MaxLength(1000, ErrorMessage = "预留字段10 不能超过 1000 个字符")]
        public string Reverse10 { get; set; }

        /// <summary>
        /// 预留字段11
        /// </summary>
        public int? ReverseI1 { get; set; }

        /// <summary>
        /// 预留字段12
        /// </summary>
        public int? ReverseI2 { get; set; }
    }
}
