﻿/*  代码由框架生成,任何更改都可能导致被代码生成器覆盖，可自行修改。
* Ghre_ExamPaper.cs
*
*功 能： N / A
* 类 名： Ghre_ExamPaper
*
* Ver    变更日期 负责人  变更内容
* ───────────────────────────────────
*V0.01  2024/4/29 11:50:29  SimonHsiao   初版
*
* Copyright(c) 2024 Tiobon Corporation. All Rights Reserved.
*┌──────────────────────────────────┐
*│　此技术信息为本公司机密信息，未经本公司书面同意禁止向第三方披露．　│
*│　作者：SimonHsiao                                                  │
*└──────────────────────────────────┘
*/
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using SqlSugar;

namespace Tiobon.Core.Model.Models
{

    /// <summary>
    /// 试卷 (Model)
    /// </summary>
    [SugarTable("Ghre_ExamPaper", "Ghre_ExamPaper"), Entity(TableCnName = "试卷", TableName = "Ghre_ExamPaper")]
    public class Ghre_ExamPaper : BasePoco
    {

        /// <summary>
        /// 试卷编号
        /// </summary>
        [Display(Name = "PaperNo"), Description("试卷编号"), MaxLength(32, ErrorMessage = "试卷编号 不能超过 32 个字符"), EntityColumn(Unique = true)]
        public string PaperNo { get; set; }

        /// <summary>
        /// 试卷名称
        /// </summary>
        [Display(Name = "PaperName"), Description("试卷名称"), MaxLength(32, ErrorMessage = "试卷名称 不能超过 32 个字符")]
        public string PaperName { get; set; }

        /// <summary>
        /// 答题时长
        /// </summary>
        public int? AnswerTime { get; set; }

        /// <summary>
        /// 评分方式
        /// </summary>
        [Display(Name = "ScoreMethod"), Description("评分方式"), MaxLength(32, ErrorMessage = "评分方式 不能超过 32 个字符")]
        public string ScoreMethod { get; set; }

        /// <summary>
        /// 卷面总分
        /// </summary>
        [Display(Name = "TotalScore"), Description("卷面总分"), Column(TypeName = "decimal(20,2)")]
        public decimal? TotalScore { get; set; }

        /// <summary>
        /// 及格分
        /// </summary>
        [Display(Name = "PassScore"), Description("及格分"), Column(TypeName = "decimal(20,2)")]
        public decimal? PassScore { get; set; }

        /// <summary>
        /// 重考次数
        /// </summary>
        public int? RetakeTimes { get; set; }

        /// <summary>
        /// 关联类型
        /// </summary>
        [Display(Name = "LinkType"), Description("关联类型"), MaxLength(32, ErrorMessage = "关联类型 不能超过 32 个字符")]
        public string LinkType { get; set; }

        /// <summary>
        /// 关联ID
        /// </summary>
        public long? LinkId { get; set; }

        /// <summary>
        /// 关联次数
        /// </summary>
        public int? LinkTimes { get; set; }

        /// <summary>
        /// 封面图片URL
        /// </summary>
        [Display(Name = "CoverUrl"), Description("封面图片URL"), MaxLength(64, ErrorMessage = "封面图片URL 不能超过 64 个字符")]
        public string CoverUrl { get; set; }

        /// <summary>
        /// 封面图片背景
        /// </summary>
        [Display(Name = "CoverBackGround"), Description("封面图片背景"), MaxLength(64, ErrorMessage = "封面图片背景 不能超过 64 个字符")]
        public string CoverBackGround { get; set; }

        /// <summary>
        /// 试卷风格
        /// </summary>
        [Display(Name = "Style"), Description("试卷风格"), MaxLength(32, ErrorMessage = "试卷风格 不能超过 32 个字符")]
        public string Style { get; set; }

        /// <summary>
        /// 出题方式
        /// </summary>
        [Display(Name = "SetMethod"), Description("关联类型"), MaxLength(32, ErrorMessage = "关联类型 不能超过 32 个字符")]
        public string SetMethod { get; set; }

        /// <summary>
        /// 状态
        /// </summary>
        [Display(Name = "Status"), Description("状态"), MaxLength(32, ErrorMessage = "状态 不能超过 32 个字符")]
        public string Status { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [Display(Name = "RemarkSz"), Description("备注"), MaxLength(2000, ErrorMessage = "备注 不能超过 2000 个字符")]
        public string RemarkSz { get; set; }

        /// <summary>
        /// 默认标志
        /// </summary>
        public int? IsDefault { get; set; }

        /// <summary>
        /// 预留字段1
        /// </summary>
        [Display(Name = "Reverse1"), Description("预留字段1"), MaxLength(1000, ErrorMessage = "预留字段1 不能超过 1000 个字符")]
        public string Reverse1 { get; set; }

        /// <summary>
        /// 预留字段2
        /// </summary>
        [Display(Name = "Reverse2"), Description("预留字段2"), MaxLength(1000, ErrorMessage = "预留字段2 不能超过 1000 个字符")]
        public string Reverse2 { get; set; }

        /// <summary>
        /// 预留字段3
        /// </summary>
        [Display(Name = "Reverse3"), Description("预留字段3"), MaxLength(1000, ErrorMessage = "预留字段3 不能超过 1000 个字符")]
        public string Reverse3 { get; set; }

        /// <summary>
        /// 预留字段4
        /// </summary>
        [Display(Name = "Reverse4"), Description("预留字段4"), MaxLength(1000, ErrorMessage = "预留字段4 不能超过 1000 个字符")]
        public string Reverse4 { get; set; }

        /// <summary>
        /// 预留字段5
        /// </summary>
        [Display(Name = "Reverse5"), Description("预留字段5"), MaxLength(1000, ErrorMessage = "预留字段5 不能超过 1000 个字符")]
        public string Reverse5 { get; set; }

        /// <summary>
        /// 预留字段6
        /// </summary>
        [Display(Name = "Reverse6"), Description("预留字段6"), MaxLength(1000, ErrorMessage = "预留字段6 不能超过 1000 个字符")]
        public string Reverse6 { get; set; }

        /// <summary>
        /// 预留字段7
        /// </summary>
        [Display(Name = "Reverse7"), Description("预留字段7"), MaxLength(1000, ErrorMessage = "预留字段7 不能超过 1000 个字符")]
        public string Reverse7 { get; set; }

        /// <summary>
        /// 预留字段8
        /// </summary>
        [Display(Name = "Reverse8"), Description("预留字段8"), MaxLength(1000, ErrorMessage = "预留字段8 不能超过 1000 个字符")]
        public string Reverse8 { get; set; }

        /// <summary>
        /// 预留字段9
        /// </summary>
        [Display(Name = "Reverse9"), Description("预留字段9"), MaxLength(1000, ErrorMessage = "预留字段9 不能超过 1000 个字符")]
        public string Reverse9 { get; set; }

        /// <summary>
        /// 预留字段10
        /// </summary>
        [Display(Name = "Reverse10"), Description("预留字段10"), MaxLength(1000, ErrorMessage = "预留字段10 不能超过 1000 个字符")]
        public string Reverse10 { get; set; }

        /// <summary>
        /// 预留字段11
        /// </summary>
        public int? ReverseI1 { get; set; }

        /// <summary>
        /// 预留字段12
        /// </summary>
        public int? ReverseI2 { get; set; }
    }
}
