﻿/*  代码由框架生成,任何更改都可能导致被代码生成器覆盖，可自行修改。
* Ghrs_Attachment.cs
*
*功 能： N / A
* 类 名： Ghrs_Attachment
*
* Ver    变更日期 负责人  变更内容
* ───────────────────────────────────
*V0.01  2024/6/27 11:34:43  SimonHsiao   初版
*
* Copyright(c) 2024 Tiobon Corporation. All Rights Reserved.
*┌──────────────────────────────────┐
*│　此技术信息为本公司机密信息，未经本公司书面同意禁止向第三方披露．　│
*│　作者：SimonHsiao                                                  │
*└──────────────────────────────────┘
*/ 
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using SqlSugar;

namespace Tiobon.Core.Model.Models
{

    /// <summary>
    /// Ghrs_Attachment (Model)
    /// </summary>
    [SugarTable("Ghrs_Attachment", "Ghrs_Attachment"), Entity(TableCnName = "Ghrs_Attachment", TableName = "Ghrs_Attachment")]
    public class Ghrs_Attachment : BasePoco1
    {

        /// <summary>
        /// Ghr附件记录ID
        /// </summary>
        public int? AttachmentID { get; set; }

        /// <summary>
        /// 文件编号
        /// </summary>
        [Display(Name = "AttachmentNo"), Description("文件编号"), MaxLength(100, ErrorMessage = "文件编号 不能超过 100 个字符")]
        public string AttachmentNo { get; set; }

        /// <summary>
        /// 说明
        /// </summary>
        [Display(Name = "AttachmentName"), Description("说明"), MaxLength(200, ErrorMessage = "说明 不能超过 200 个字符")]
        public string AttachmentName { get; set; }

        /// <summary>
        /// 英文说明
        /// </summary>
        [Display(Name = "AttachmentEname"), Description("英文说明"), MaxLength(500, ErrorMessage = "英文说明 不能超过 500 个字符")]
        public string AttachmentEname { get; set; }

        /// <summary>
        /// TableName
        /// </summary>
        [Display(Name = "TableName"), Description("TableName"), MaxLength(200, ErrorMessage = "TableName 不能超过 200 个字符")]
        public string TableName { get; set; }

        /// <summary>
        /// TableKeyID
        /// </summary>
        public int? TableKeyID { get; set; }

        /// <summary>
        /// StaffID
        /// </summary>
        public int? StaffID { get; set; }

        /// <summary>
        /// 文件类别 (基本资料/证照/加班/请假....)
        /// </summary>
        [Display(Name = "AttachmentType"), Description("文件类别 (基本资料/证照/加班/请假....)"), MaxLength(100, ErrorMessage = "文件类别 (基本资料/证照/加班/请假....) 不能超过 100 个字符")]
        public string AttachmentType { get; set; }

        /// <summary>
        /// AttachmentGroupID
        /// </summary>
        public int? AttachmentGroupID { get; set; }

        /// <summary>
        /// 文件名
        /// </summary>
        [Display(Name = "AttachFileName"), Description("文件名"), MaxLength(200, ErrorMessage = "文件名 不能超过 200 个字符")]
        public string AttachFileName { get; set; }

        /// <summary>
        /// AttachBinary
        /// </summary>

        /// <summary>
        /// 扩展名
        /// </summary>
        [Display(Name = "AttachFileExtension"), Description("扩展名"), MaxLength(100, ErrorMessage = "扩展名 不能超过 100 个字符")]
        public string AttachFileExtension { get; set; }

        /// <summary>
        /// 大小
        /// </summary>
        public int? AttachFileSize { get; set; }

        /// <summary>
        /// 物理路径
        /// </summary>
        [Display(Name = "PhysicsPath"), Description("物理路径"), MaxLength(500, ErrorMessage = "物理路径 不能超过 500 个字符")]
        public string PhysicsPath { get; set; }

        /// <summary>
        /// 相对路径
        /// </summary>
        [Display(Name = "RelativePath"), Description("相对路径"), MaxLength(500, ErrorMessage = "相对路径 不能超过 500 个字符")]
        public string RelativePath { get; set; }

        /// <summary>
        /// ThumbnailPath
        /// </summary>
        [Display(Name = "ThumbnailPath"), Description("ThumbnailPath"), MaxLength(500, ErrorMessage = "ThumbnailPath 不能超过 500 个字符")]
        public string ThumbnailPath { get; set; }

        /// <summary>
        /// 附件网页链接地址
        /// </summary>
        [Display(Name = "FileURL"), Description("附件网页链接地址"), MaxLength(500, ErrorMessage = "附件网页链接地址 不能超过 500 个字符")]
        public string FileURL { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [Display(Name = "RemarkSz"), Description("备注"), MaxLength(2000, ErrorMessage = "备注 不能超过 2000 个字符")]
        public string RemarkSz { get; set; }

        /// <summary>
        /// SortNo
        /// </summary>
        public int? SortNo { get; set; }

        /// <summary>
        /// IsDefault
        /// </summary>
        public int? IsDefault { get; set; }

        /// <summary>
        /// CompanyID
        /// </summary>
        public int? CompanyID { get; set; }

        /// <summary>
        /// ReverseN1
        /// </summary>
        public int? ReverseN1 { get; set; }

        /// <summary>
        /// ReverseD1
        /// </summary>
        public DateTime? ReverseD1 { get; set; }

        /// <summary>
        /// Reverse1
        /// </summary>
        [Display(Name = "Reverse1"), Description("Reverse1"), MaxLength(1000, ErrorMessage = "Reverse1 不能超过 1000 个字符")]
        public string Reverse1 { get; set; }

        /// <summary>
        /// Reverse2
        /// </summary>
        [Display(Name = "Reverse2"), Description("Reverse2"), MaxLength(1000, ErrorMessage = "Reverse2 不能超过 1000 个字符")]
        public string Reverse2 { get; set; }

        /// <summary>
        /// Reverse3
        /// </summary>
        [Display(Name = "Reverse3"), Description("Reverse3"), MaxLength(1000, ErrorMessage = "Reverse3 不能超过 1000 个字符")]
        public string Reverse3 { get; set; }

        /// <summary>
        /// Reverse4
        /// </summary>
        [Display(Name = "Reverse4"), Description("Reverse4"), MaxLength(1000, ErrorMessage = "Reverse4 不能超过 1000 个字符")]
        public string Reverse4 { get; set; }

        /// <summary>
        /// Reverse5
        /// </summary>
        [Display(Name = "Reverse5"), Description("Reverse5"), MaxLength(1000, ErrorMessage = "Reverse5 不能超过 1000 个字符")]
        public string Reverse5 { get; set; }
    }
}
