﻿using Tiobon.Core.Model.Models;

namespace Tiobon.Core.Model;

public class DefaultGhre_ExamPaperInput
{
    public List<DefaultGhre_ExamPaperColumn> baseColumns { get; set; } = new List<DefaultGhre_ExamPaperColumn>();
    public List<DefaultGhre_ExamPaperColumn> randomSetColumns { get; set; } = new List<DefaultGhre_ExamPaperColumn>();
    public List<DefaultGhre_ExamPaperColumn> manualSetColumns { get; set; } = new List<DefaultGhre_ExamPaperColumn>();
    public DefaultGhre_ExamPaperPageData pageData { get; set; } = new DefaultGhre_ExamPaperPageData();

    /// <summary>
    /// 修改信息 黄一名 于 2024-05-10 15:02 最后修改
    /// </summary>
    public string UpdateDataInfo { get; set; }

    /// <summary>
    /// 创建信息 黄一名 于 2024-05-10 14:57 创建
    /// </summary>
    public string CreateDataInfo { get; set; }
}
public class DefaultGhre_ExamPaperColumn
{
    public string label { get; set; }
    public string field { get; set; }
    public string elementType { get; set; }
    public bool required { get; set; }
    public bool multipleSelect { get; set; }
    public bool editable { get; set; }
    public string dataSource { get; set; }
    public string placeholder { get; set; }

    public int displayType { get; set; }
    public int width { get; set; } = 150;

}


public class DefaultGhre_ExamPaperPageData
{
    public DefaultGhre_ExamPaperBaseData baseData { get; set; } = new DefaultGhre_ExamPaperBaseData();
    public DefaultGhre_ExamPaperStyleInfo styleInfo { get; set; } = new DefaultGhre_ExamPaperStyleInfo();
    public string examPaperSetType { get; set; }
    public List<Ghre_ExamPaperConfig> examPaperSetData { get; set; } = new List<Ghre_ExamPaperConfig> { };
    public List<DefaultGhre_ExamPaperPreview> previewList { get; set; } = new List<DefaultGhre_ExamPaperPreview> { };
    public List<DefaultGhre_ExamPaperPreview> questionList { get; set; } = new List<DefaultGhre_ExamPaperPreview> { };
     

}
public class DefaultGhre_ExamPaperBaseData : Ghre_ExamPaperBase
{
    public long? CourseId { get; set; }
    public long? CourseSceneId { get; set; }
}
public class DefaultGhre_ExamPaperStyleInfo
{
    public string coverImage { get; set; }
    public string paperStyle { get; set; }
    public string coverBackGround { get; set; } = "rgba(0, 0, 0, 0.4)";
}
public class DefaultGhre_ExamPaperPreview
{
    public long? parentId { get; set; }
    public long Id { get; set; }
    /// <summary>
    /// 试卷ID
    /// </summary>
    public long? ExamPaperId { get; set; }

    /// <summary>
    /// 题目ID
    /// </summary> 
    public long QuestionId { get; set; }

    /// <summary>
    /// 题目类型
    /// </summary>
    public string QuestionType { get; set; }

    /// <summary>
    /// 题目内容
    /// </summary>
    public string QuestionContent { get; set; }

    /// <summary>
    /// 试卷配置ID
    /// </summary>
    public long? ConfigId { get; set; }
    public FromGhre_QuestionQuestionTypeDetail detail { get; set; } = new FromGhre_QuestionQuestionTypeDetail();

    public decimal? Score { get; set; }
    public decimal? RealScore { get; set; }
    public string value { get; set; }
    public List<string> value1 { get; set; } = new List<string> { };
}
public class InsertExamPaperConfigInput
{
    public Ghre_ExamPaperConfig tableData { get; set; } = new Ghre_ExamPaperConfig();
    public List<DefaultGhre_ExamPaperPreview> previewList { get; set; } = new List<DefaultGhre_ExamPaperPreview> { };

}